; Copyright (c) 1990-2003
;	Wada Laboratory, the University of Tokyo. All rights reserved.
; Copyright (c) 2003-2007
;	Electronic Font Open Laboratory (/efont/). All rights reserved.
;
; Redistribution and use in source and binary forms, with or without
; modification, are permitted provided that the following conditions
; are met:
; 1. Redistributions of source code must retain the above copyright notice, 
;    this list of conditions and the following disclaimer.
; 2. Redistributions in binary form must reproduce the above copyright notice,
;    this list of conditions and the following disclaimer in the documentation 
;    and/or other materials provided with the distribution.
; 3. Neither the name of the Wada Laboratory, the University of Tokyo nor
;    the names of its contributors may be used to endorse or promote products 
;    derived from this software without specific prior written permission.
;
; THIS SOFTWARE IS PROVIDED BY WADA LABORATORY, THE UNIVERSITY OF TOKYO AND
; CONTRIBUTORS ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT
; NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
; PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE LABORATORY OR
; CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
; EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;
; $Id: limit.l,v 1.12 2007/05/16 04:08:59 kanou Exp $

;; ԤƬ ;# ǻϤޤΤϥꥸʥ륳, ;; ϤФ
;; ˴ؤ륳Ȥ ;: ǻϤޤ

; limit.l: Ԥ롼 (ȹ礻η׻˻Ȥ)
;
; [1] section () α黻
;	rm-eq, eqsym, gt, lt, orsection, andsection, revsym, notsection
; [2] limitrule ɾ
;       xpair, ypair, eval-exp, inequal1, inequal2, gtsection, 
;	limit-section{,1,2}, extendline, crosst, equation2(̤)
; [3] ̵򺵾Ƚ
;	epsp, equation_ts, crosst1, line-cross, check-res, rmbigres,
;	res2section, extend-element, element-limit{,1,2}, add0vector, addvector
; [4] ȹ礻 ([2]  [3] ξ) 
;	general-section{,1}, section2s, general-limit
;                                       ^^^^^^^^^^^^^

(defvar revtable)
(declaim (inline rm-eq eqsym lt xpair ypair extendline epsp))

;# section () η
;# nil ¤ʤ
;# ((nil . 1.0)(2.0 . nil))Τ(sorted)
;
; üɽ:
;   - = nil, + = t, ü = ¿, ü = (> . ¿), ü = (< . ¿)
; ñ֤ (ü . ü) ΥɥåФɽ
;
; ̤ζ֤ϡ1 İʾñ֤򾮤¤٤ꥹȤɽ
; 㤨С((nil . 1.0) (2.0 . nil))  (-, 1.0]  [2.0, ) ɽ졢
; ((3.0 . 3.0)) Τ褦Ĺ 0 Ķ֤ɽ (Ĺ 0 γ֤Ǥ)
;  nil ɽ

;
; ֤üɽɥåФͤ (rm-eq), ޤ (eqsym)
;
(defun rm-eq (a)
  (cond ((consp a) (cdr a))
	(t a)))
;
(defun eqsym (a)
  (and (consp a) (car a)))

;
; ֤ü a, b 羮
;
; ɬ    ΩĤΤǡƱʹطǤϤʤ 
; a = b ΤȤ羮طϰʲΤ褦롣
; Ǥϡü (a, }, 峫ü {, a), ü [a] ɽƤ롣
;
;  (-, }  (-, },  {, +)  {, +), 
;   (x, }   (x, } ,    (x, }   {, x),     (x, }   [x],
;   {, x)   (x, } ,    {, x)   {, x),     {, x)   [x],
;     [x]     (x, } ,      [x]     {, x),       [x]     [x],
;
(defun gt (a b)
  (cond ((null a) nil)
	((null b) t)
	((eq a 't) t)
	((eq b 't) nil)
	(t
	 (let* ((aa (rm-eq a)) (bb (rm-eq b)))
	   (cond ((< aa bb) nil)
		 ((> aa bb) t)
		 ((eq '> (eqsym a)) t)
		 ((eq '> (eqsym b)) nil)
		 ((eq '< (eqsym a)) nil)
;		 ((eq '< (eqsym b)) t)
;		 (t))))))
		 (t t))))))
;
(defun lt (a b) (not (gt a b)))

;
; orsection: s1  s2 ιʻ
;
(defun orsection (s1 s2)
;  (pprint (list "orsection" s1 s2))
  (cond 
   ((null s1) s2)
   ((null s2) s1)
   (t
    (let ((ret)
	  (cursec (cond ((gt (caar s2)(caar s1))
			 (prog1 (car s1) (setq s1 (cdr s1))))
			(t (prog1 (car s2) (setq s2 (cdr s2)))))))
      (loop
;       (pprint (list s1 s2))
       (cond ((and s1 (gt (cdr cursec)(caar s1)))
	      (cond ((gt (cdr cursec)(cdar s1)))
		    (t (setq cursec (cons (car cursec)(cdar s1)))))
	      (setq s1 (cdr s1)))
	     ((and s2 (gt (cdr cursec)(caar s2)))
	      (cond ((gt (cdr cursec)(cdar s2)))
		    (t (setq cursec (cons (car cursec)(cdar s2)))))
	      (setq s2 (cdr s2)))
	     (t
	      (push cursec ret)
	      (cond ((and s1 s2)
		     (setq cursec (cond ((gt (caar s2)(caar s1))
					 (prog1 (car s1) (setq s1 (cdr s1))))
					(t (prog1 (car s2)(setq s2 (cdr s2)))))))
		    (s1
		     (setq cursec (car s1))
		     (setq s1 (cdr s1)))
		    (s2
		     (setq cursec (car s2))
		     (setq s2 (cdr s2)))
		    (t (return (nreverse ret)))))))))))
;
; andsection: ̽
;
(defun andsection (s1 s2)
;  (pprint (list "andsection" s1 s2))
  (let ((ret))
    (loop
     (cond ((and s1 s2)
	    (cond ((lt (caar s2)(caar s1))
		   (cond ((gt (caar s1)(cdar s2))
			  (setq s2 (cdr s2)))
			 (t
			  (cond ((gt (cdar s1)(cdar s2))
				 (push (cons (caar s1) (cdar s2)) ret)
				 (setq s2 (cdr s2)))
				(t
				 (push (car s1) ret)
				 (setq s1 (cdr s1)))))))
		  (t
		   (cond ((lt (cdar s1)(caar s2))
			  (setq s1 (cdr s1)))
			 (t
			  (cond ((gt (cdar s2)(cdar s1))
				 (push (cons (caar s2) (cdar s1)) ret)
				 (setq s1 (cdr s1)))
				(t
				 (push (car s2) ret)
				 (setq s2 (cdr s2)))))))))
	   (t (return (nreverse ret)))))))

; üγĤȿž
;
(defun revsym (val sym)
  (cond ((consp val) (cdr val))
	((null val) nil)
	((eq val 't) t)
	(t (cons sym val))))
;
; notsection: 佸
;
(defun notsection (section)
;  (pprint (list "notsection" section))
  (do ((l section (cdr l))
       (lastmax nil)
       (ret))
    ((atom l)
     (and (not (eq lastmax 't)) (push (cons (revsym lastmax '>) t) ret))
     (nreverse ret))
    (cond ((and (null lastmax)(null (caar l))))
	  ((equal lastmax (caar l)))
	  (t
	   (push (cons (revsym lastmax '>) (revsym (caar l) '<)) ret)))
    (setq lastmax (cdar l))))
;
;#  exp ɾ (at + b) ηˤ
;
; original 
;(defun eval-exp (exp e1 p1 e2 p2 param)
;  (let* ((exp1))
;    (cond ((and (assq 'reverse param)
;		(setq exp1 (assq exp revtable)))
;	   (setq exp (cdr exp1)))
;	  ((and (memq exp '(xlimit ylimit))(not (assq exp param)))
;	   (setq exp '(0 . 0)))))
;  (match exp
;    (('+ a b)
;     (let ((l1 (eval-exp a e1 p1 e2 p2 param))
;	    (l2 (eval-exp b e1 p1 e2 p2 param)))
;       (cons (+ (car l1)(car l2)) (+ (cdr l1)(cdr l2)))))
;    (('* a b)
;     (let ((l1 (eval-exp a e1 p1 e2 p2 param))
;	    (l2 (eval-exp b e1 p1 e2 p2 param)))
;       (cons (* (car l1)(car l2)) (* (cdr l1)(cdr l2)))))
;    (('- a b)
;     (let ((l1 (eval-exp a e1 p1 e2 p2 param))
;	    (l2 (eval-exp b e1 p1 e2 p2 param)))
;       (cons (- (car l1)(car l2)) (- (cdr l1)(cdr l2)))))
;    (('abs a)
;     (cons 'abs (eval-exp a e1 p1 e2 p2 param)))
;    (('diffabs a b)
;     (let ((l1 (eval-exp a e1 p1 e2 p2 param))
;	    (l2 (eval-exp b e1 p1 e2 p2 param)))
;       (list* 'abs (- (car l1)(car l2)) (- (cdr l1)(cdr l2)))))
;    (('quote a) a)
;    ('x00 (xpair (nth (car (cadr e1)) p1)))
;    ('x01 (xpair (nth (cadr (cadr e1)) p1)))
;    ('x02 (xpair (nth (caddr (cadr e1)) p1)))
;    ('x03 (xpair (nth (cadddr (cadr e1)) p1)))
;    ('x10 (xpair (nth (car (cadr e2)) p2)))
;    ('x11 (xpair (nth (cadr (cadr e2)) p2)))
;    ('x12 (xpair (nth (caddr (cadr e2)) p2)))
;    ('x13 (xpair (nth (cadddr (cadr e2)) p2)))
;    ('y00 (ypair (nth (car (cadr e1)) p1)))
;    ('y01 (ypair (nth (cadr (cadr e1)) p1)))
;    ('y02 (ypair (nth (caddr (cadr e1)) p1)))
;    ('y03 (ypair (nth (cadddr (cadr e1)) p1)))
;    ('y10 (ypair (nth (car (cadr e2)) p2)))
;    ('y11 (ypair (nth (cadr (cadr e2)) p2)))
;    ('y12 (ypair (nth (caddr (cadr e2)) p2)))
;    ('y13 (ypair (nth (cadddr (cadr e2)) p2)))
;    (var (cond ((symbolp var)
;		(cdr (assq var param)))
;	       (t var)))))
;
(setq revtable 
      '((x00 . x10)  (x01 . x11)  (x02 . x12)  (x03 . x13)
	(x10 . x00)  (x11 . x01)  (x12 . x02)  (x13 . x03)
        (y00 . y10)  (y01 . y11)  (y02 . y12)  (y03 . y13)
	(y10 . y00)  (y11 . y01)  (y12 . y02)  (y13 . y03)))
;
(defun xpair (p)
  (cons (car (cadr p)) (car (car p))))
;
(defun ypair (p)
  (cons (cadr (cadr p)) (cadr (car p))))
;
;: match Ȥʤ褦ˤƹ®ޤä
;
(defun eval-exp (exp e1 p1 e2 p2 param)
  (let* ((exp1))
    (cond ((and (assq 'reverse param)
		(setq exp1 (assq exp revtable)))
	   (setq exp (cdr exp1)))
	  ((and (memq exp '(xlimit ylimit)) (not (assq exp param)))
	   (setq exp '(0 . 0)))))
  (cond 
   ((listp exp)
    (case (car exp)
	  ((+) (let ((l1 (eval-exp (cadr exp) e1 p1 e2 p2 param))
		     (l2 (eval-exp (caddr exp) e1 p1 e2 p2 param)))
		 (cons (+ (car l1)(car l2)) (+ (cdr l1)(cdr l2)))))
	  ((*) (let ((l1 (eval-exp (cadr exp) e1 p1 e2 p2 param))
		     (l2 (eval-exp (caddr exp) e1 p1 e2 p2 param)))
		 (cons (* (car l1)(car l2)) (* (cdr l1)(cdr l2)))))
	  ((-) (let ((l1 (eval-exp (cadr exp) e1 p1 e2 p2 param))
		     (l2 (eval-exp (caddr exp) e1 p1 e2 p2 param)))
		 (cons (- (car l1)(car l2)) (- (cdr l1)(cdr l2)))))
	  ((abs) (cons 'abs (eval-exp (cadr exp) e1 p1 e2 p2 param)))
	  ((diffabs)
	   (let ((l1 (eval-exp (cadr exp) e1 p1 e2 p2 param))
		 (l2 (eval-exp (caddr exp) e1 p1 e2 p2 param)))
	     (list* 'abs (- (car l1) (car l2)) (- (cdr l1) (cdr l2)))))
	  ((quote) (cadr exp))
	  (otherwise exp)))
   ((symbolp exp)
    (case exp						; иٽ˥
	  ((x11) (xpair (nth (cadr (cadr e2)) p2)))		; 66
	  ((x00) (xpair (nth (car (cadr e1)) p1)))		; 64
	  ((y01) (ypair (nth (cadr (cadr e1)) p1)))		; 64
	  ((y00) (ypair (nth (car (cadr e1)) p1)))		; 62
	  ((x01) (xpair (nth (cadr (cadr e1)) p1)))		; 61
	  ((y11) (ypair (nth (cadr (cadr e2)) p2)))		; 59
	  ((y10) (ypair (nth (car (cadr e2)) p2)))		; 53
	  ((x12) (xpair (nth (caddr (cadr e2)) p2)))		; 45
	  ((x10) (xpair (nth (car (cadr e2)) p2)))		; 42
	  ((y12) (ypair (nth (caddr (cadr e2)) p2)))		; 29
	  ((x02) (xpair (nth (caddr (cadr e1)) p1)))		; 18
	  ((y02) (ypair (nth (caddr (cadr e1)) p1)))		; 12
	  ((x13) (xpair (nth (cadddr (cadr e2)) p2)))		;  6
	  ((y03) (ypair (nth (cadddr (cadr e1)) p1)))		;  3
	  ((y13) (ypair (nth (cadddr (cadr e2)) p2)))		;  2
	  ((x03) (xpair (nth (cadddr (cadr e1)) p1)))		;  1
	  (otherwise (cdr (assq exp param)))))
    (t exp)))
;
;#  aX + b >= 0 βζ֤֤
;
(defun inequal1 (a b)
;  (pprint (cons a b))
  (cond ((zerop a)
	 (cond ((not (minusp b))
		'((nil . t)))
	       (t nil)))
	((zerop b)
	 (cond ((not (minusp a))
		'((0 . t)))
	       (t '((nil . 0)))))
	((plusp a)
	 (list (cons (/ (float b) (float (minus a))) t)))
	(t
	 (list (cons nil (/ (float b) (float (minus a))))))))
;
;#  aX^2 + bX + c >= 0 βζ֤֤
;
;; ( deflimit ǤϻѤʤ)
;
(defun inequal2 (a b c)
  (cond ((zerop a)
	 (inequal1 b c))
	(t
	 (let* ((d (- (* b b) (* 4 a c)))
		(sqrtd (and (not (minusp d)) (sqrt (float d)))))
	   (cond ((plusp a)
		  (cond (sqrtd
			 (list (cons nil (/ (+ sqrtd b) -2.0 (float a)))
			       (cons (/ (- sqrtd b) 2.0 (float a)) t)))
			(t '((nil . t)))))
		 (t
		  (cond (sqrtd
			 (list (cons (/ (- sqrtd b) 2.0 (float a))
				     (/ (+ sqrtd b) -2.0 (float a)))))
			(t nil))))))))
;
;#  ex1 >= ex2 βζ֤֤
;
; original
;(defun gtsection (ex1 ex2 e1 p1 e2 p2 param)
;  (let* ((ex1 (eval-exp ex1 e1 p1 e2 p2 param))
;	 (ex2 (eval-exp ex2 e1 p1 e2 p2 param)))
;;    (pprint (list ex1 ex2))
;    (match (cons ex1 ex2)
;      ((('abs t1 . c1) . (t2 . c2))
;;       (pprint (list t1 c1 t2 c2))
;       (orsection
;	(andsection
;	 (inequal1 (- t1 t2) (- c1 c2))
;	 (inequal1 t1 c1))
;	(andsection
;	 (inequal1 (minus (+ t1 t2)) (minus(+ c1 c2)))
;	 (inequal1 (minus t1) (minus c1)))))
;      (((t1 . c1) . ('abs t2 . c2))
;       (orsection
;	(andsection
;	 (inequal1 (- t1 t2) (- c1 c2))
;	 (inequal1 t2 c2))
;	(andsection
;	 (inequal1 (+ t1 t2) (+ c1 c2))
;	 (inequal1 (minus t2) (minus c2)))))
;      (((t1 . c1) . (t2 . c2))
;       (inequal1 (- t1 t2) (- c1 c2)))
;      (dummy
;       (print "Not supported Such expression" *terminal-io*)
;       (print (cons ex1 ex2) *terminal-io*)))))
;
;: match ȤʤС
;
(defun gtsection (ex1 ex2 e1 p1 e2 p2 param)
  (let* ((ex1 (eval-exp ex1 e1 p1 e2 p2 param))
	 (ex2 (eval-exp ex2 e1 p1 e2 p2 param)))
;   (pprint (list ex1 ex2))
    (cond
     ((eq (car ex1) 'abs)
      (let ((t1 (cadr ex1)) (c1 (cddr ex1))
	    (t2 (car ex2)) (c2 (cdr ex2)))
;	(pprint (list t1 c1 t2 c2))
	(orsection
	 (andsection
	  (inequal1 (- t1 t2) (- c1 c2))
	  (inequal1 t1 c1))
	 (andsection
	  (inequal1 (minus (+ t1 t2)) (minus(+ c1 c2)))
	  (inequal1 (minus t1) (minus c1))))))
     ((eq (car ex2) 'abs)
      (let ((t1 (car ex1)) (c1 (cdr ex1))
	    (t2 (cadr ex2)) (c2 (cddr ex2)))
	(orsection
	 (andsection
	  (inequal1 (- t1 t2) (- c1 c2))
	  (inequal1 t2 c2))
	 (andsection
	  (inequal1 (+ t1 t2) (+ c1 c2))
	  (inequal1 (minus t2) (minus c2))))))
     (t
       (inequal1 (- (car ex1) (car ex2)) (- (cdr ex1) (cdr ex2)))))))
;
; limit-section: limitrule 顢񿨤ϰ (section) 
;
(defun limit-section2 (e1 p1 e2 p2 param def)
  (case (car def)
    (or
     (do ((l (cdr def) (cdr l))
	  (ret))
       ((atom l) ret)
       (setq ret 
	     (orsection ret (limit-section2  e1 p1 e2 p2 param (car l))))))
    (and
     (do ((l (cdr def) (cdr l))
	  (ret '((nil . t))))
       ((atom l) ret)
       (setq ret (andsection 
		  ret (limit-section2 e1 p1 e2 p2 param (car l))))))
    (>=
     (do ((l (cddr def) (cdr l))
	  (ret (gtsection (cadr def) (caddr def) e1 p1 e2 p2 param)))
       ((atom (cdr l)) ret)
       (setq ret (andsection 
		  ret (gtsection (car l) (cadr l) e1 p1 e2 p2 param)))))
    (<=
     (do ((l (cddr def) (cdr l))
	  (ret (gtsection (caddr def) (cadr def) e1 p1 e2 p2 param)))
       ((atom (cdr l)) ret)
       (setq ret (andsection 
		  ret (gtsection (cadr l) (car l) e1 p1 e2 p2 param)))))
    (print
     (pprint `((,(car e1)
		.,(mapcar #'(lambda (x) (nth x p1)) (cadr e1)))
	       (,(car e2)
		.,(mapcar #'(lambda (x) (nth x p2)) (cadr e2)))))
     (print (limit-section2 e1 p1 e2 p2 param (cadr def))))))
;
(defun limit-section1 (e1 p1 e2 p2 param def)
  (let ((sec1 (limit-section2 e1 p1 e2 p2 param (car def)))
	(sec2 (limit-section2 e1 p1 e2 p2 param (cadr def))))
;    (pprint (list e1 e2 sec1 sec2))
    (andsection sec1 (notsection sec2))))
;
(defun limit-section (e1 p1 e2 p2 param def)
  (do ((l def (cdr l))
       (ret1)
       (ret))
    ((atom l) ret)
    (setq ret1 (limit-section1 e1 p1 e2 p2 param (car l)))
    (cond (ret (setq ret (orsection ret ret1)))
	  (t (setq ret ret1)))))
;
;
(defparameter delta 0.0)
;
(defun extendline (a b s)
  (plus2 a (times2 (/ s 2.0) (diff2 a b))))
;
; (߻ѤƤʤ)
;
(defun crosst (a b c)
  (let* (
;	 (a (extendline a b delta))
;	 (b (extendline b a (/ delta (+ 1.0 delta))))
	 (p (car c))
	 (q (cadr c))
	 (diff (diff2 b a))
	 (mat (vector (car q) (cadr q) (car diff) (cadr diff))))
;    (pprint (list a b c))
    (cond ((zerop (- (* (car q) (cadr diff)) 
		     (* (cadr q) (car diff))))
	   nil)
	  (t
	   (let* ((rmat (rmat mat))
		  (rconv (vector (svref rmat 0) (svref rmat 1)
				 (svref rmat 2) (svref rmat 3)
				 0 0))
		  (bp (diff2 b p))
		  (ts))
	     (setq ts (affine bp rconv))
;	     (pprint (list bp mat rconv ts))
;	     (pprint ts)
	     (cond ((<= (minus delta) (cadr ts) (+ 1.0 delta))
		    (list (car ts)))
		   (t nil)))))))
;
;#  aX^2 + bX + c = 0 μ¿Υꥹ (ŲʣƵ󤲤)
;
(defun equation2 (a b c)
  (cond ((zerop a)
	 (list (minus (/ c b))))
	(t
	 (let* ((d (- (* b b) (* 4 a c)))
		(sqrtd (and (not (minusp d)) (sqrt d))))
	   (cond (sqrtd
		  (list (/ (+ sqrtd b) -2.0 a)
			(/ (- sqrtd b) 2.0 a)))
		 (t nil))))))
;
;#  equation_ts
;
; ʸʹˤȥեȤκ p.46 :
; (ֹϰѼԤˤɲ)
;
;| ʬ AB  CD ˸Ȥϡ
;|
;|       (Ax - Cx) * (By - Ay) - (Ay - Cy) * (Bx - Ax)
;| 0    1  ġġġġ [1]
;|       (Cx - Dx) * (By - Ay) - (Cy - Dy) * (Bx - Ax)
;|
;|       (Cx - Ax) * (Dy - Cy) - (Cy - Ay) * (Dx - Cx)
;| 0    1  ġġġġ [2]
;|       (Dx - Cx) * (Ay - By) - (Dy - Cy) * (Ax - Bx)
;|
;| Ƚ񤱤. Ax  t ΣǤ뤿, ϣͭη
;| ɽ, ʬ򤹤뤳Ȥˤä, ȤƲ򤯤ȤǤ.
;
; ѿ̾Ѥ [1]  0  (ab + ac - bc) / (bc + bd - ac - ad)  1,
;                      [2]  0  (cd - ac - ad) / (bc + bd - ac - ad)  1 
; Ƚ񤭴롣
;
(defun epsp (x) (< (abs x) 1.0d-7))
;
(defun equation_ts (a1 b1 c1 d1 a2 b2 c2 d2)
  (declare (double-float a1 b1 c1 d1 a2 b2 c2 d2))
  (let* ((ab (- (* a1 b2) (* a2 b1)))
	 (ac (- (* a2 c1) (* a1 c2)))
	 (ad (- (* a1 d2) (* a2 d1)))
	 (bc (- (* c1 b2) (* c2 b1)))
	 (bd (- (* d2 b1) (* d1 b2)))
	 (cd (- (* c1 d2) (* c2 d1)))
	 (res))
;   (break)
;(pprint (equation2 ab (+ ad bc) cd))
    (cond ((and (epsp a1) (epsp a2))
	   (cond ((epsp bc) nil)
		 (t `((,(/ cd (minus bc)) .,(/ bd bc))))))
	  ((and (epsp ac) (epsp ab))
	   nil)
	  ((epsp ac)
	   (setq res (/ ad (minus ab)))
	   (cond ((not (epsp (+ c1 (* a1 res))))
		  `((,res .,(/ (minus (+ d1 (* b1 res))) (+ c1 (* a1 res))))))
		 ((not (epsp (+ c2 (* a2 res))))
		  `((,res .,(/ (minus (+ d2 (* b2 res))) (+ c2 (* a2 res))))))
		 (t nil)))
	  ((epsp ab)
	   (setq res (/ ad ac))
	   (cond ((not (epsp (+ b1 (* a1 res))))
		  `((,(/ (minus (+ d1 (* c1 res))) (+ b1 (* a1 res))) .,res)))
		 ((not (epsp (+ b2 (* a2 res))))
		  `((,(/ (minus (+ d2 (* c2 res))) (+ b2 (* a2 res))) .,res)))
		 (t nil)))
	  (t
	   (do ((l (equation2 ab (+ ad bc) cd) (cdr l))
		(ret))
	       ((atom l) ret)
;(pprint `(,ab ,(car l) ,ad ,ac ,(/ (+ (* ab (car l)) ad) ac)))
	     (push `(,(car l) .,(/ (+ (* ab (car l)) ad) ac)) ret)
;(break)
	     )))))
;
;: ٤ؤѴϸƽФǹԤ褦ѹ
;
; a2, b2, c2  add0vector ޤ addvector դä줿
;
(defun crosst1 (a b c)
  (let* (
;	 (a (cons (extendline (car a) (car b) delta) (cdr a)))
;	 (b (cons (extendline (car b) (car a) (/ delta (+ 1.0d0 delta)))
;		  (cdr b)))
	 (a1 (car a))  (a1x (car a1)) (a1y (cadr a1))
	 (a2 (cadr a)) (a2x (car a2)) (a2y (cadr a2))
	 (b1 (car b))  (b1x (car b1)) (b1y (cadr b1))
	 (b2 (cadr b)) (b2x (car b2)) (b2y (cadr b2))
	 (c1 (car c))  (c1x (car c1)) (c1y (cadr c1))
	 (c2 (cadr c)) (c2x (car c2)) (c2y (cadr c2))
	 (res (equation_ts (- b2x a2x) (- a2x c2x)
			   (- b1x a1x) (- a1x c1x)
			   (- b2y a2y) (- a2y c2y)
			   (- b1y a1y) (- a1y c1y))))
;   (pprint (list a b c res))
    (do ((l res (cdr l))
	 (ret))
      ((null l) ret)
      (and (<= (minus delta) (cdar l) (+ 1.0 delta))
;      (and (<= -0.0d0 (cdar l)) (<= (cdar l) 1.0d0)) ; ΤȤ delta = 0 ʤΤǥȥ
	    (push (sfloat (caar l)) ret)))))
;
(defun line-cross (a0 a1 b0 b1)
  (let* ((mat (vector (- (car b0) (car b1)) (- (cadr b0) (cadr b1))
		      (- (car a1) (car a0)) (- (cadr a1) (cadr a0))))
	 (det (- (* (svref mat 0) (svref mat 3))
		 (* (svref mat 1) (svref mat 2))))
	 (ts)
	 (rmat) (rmatv))
    (cond ((epsp det) nil)
	  (t 
	   (setq rmatv (rmat mat))
	   (setq rmat (vector (svref rmatv 0) (svref rmatv 1)
			      (svref rmatv 2) (svref rmatv 3) 0 0))
	   (setq ts (affine (diff2 a1 b1) rmat))
	   (cond ((and (<= (minus delta) (car ts) (+ 1.0 delta))
		       (<= (minus delta) (cadr ts) (+ 1.0 delta)))
		  t)
		 (t nil))))))
;
(defun check-res (val a0 a1 b0 b1)
  (let* ((p0 (car a0)) (q0 (cadr a0))
	 (p1 (car a1)) (q1 (cadr a1))
	 (p2 (car b0)) (q2 (cadr b0))
	 (p3 (car b1)) (q3 (cadr b1))
	 (a0 (plus2 p0 (times2 val q0)))
	 (a1 (plus2 p1 (times2 val q1)))
	 (b0 (plus2 p2 (times2 val q2)))
	 (b1 (plus2 p3 (times2 val q3))))
;    (pprint (list val a0 a1 b0 b1     (line-cross a0 a1 b0 b1)))
    (line-cross a0 a1 b0 b1)))
;
(defun rmbigres (res)
  (do ((l res (cdr l))
       (ret nil))
    ((atom l) (nreverse ret))
    (cond ((> (car l) 10000.0)
	   (push 10000.0 ret))
	  ((< (car l) -10000.0)
	   (push -10000.0 ret))
	  (t (push (car l) ret)))))
;
;(defun res2section (res a0 a1 b0 b1)
;  (cond 
;   ((null res) nil)
;   (t
;    (let* ((sortres (sort (copy-list (rmbigres res)) #'>))
;	   (ret (list (check-res (+ (max (abs (* 0.5 (car sortres))) 1)
;				    (car sortres))
;				 a0 a1 b0 b1))))
;;	(pprint ret)
;      (do ((l sortres (cdr l)))
;	  ((atom (cdr l))
;	   (push (car l) ret)
;	   (push (check-res (- (car l) (max (abs (* 0.5 (car l))) 1))
;			    a0 a1 b0 b1)
;	      ret))
;	(cond 
;	 ((equal (car l) (cadr l)))
;	 (t
;	  (push (car l) ret)
;	  (push (check-res 
;		 (* 0.5 (+ (car l) (cadr l))) a0 a1 b0 b1) ret))))
;      (do ((l ret (cddr l))
;	   (sec)
;	   (last))
;	((atom (cdr l))
;	 (and (car l) (push (cons last t) sec))
;	 (nreverse sec))
;	(match l
;	  (('t val 'nil . next)
;	   (push `(,last .,val) sec))
;	  (('nil val 't . next)
;	   (setq last val))
;	  (('nil val 'nil . next)
;	   (push (cons val val) sec)
;;	   (pprint sec)
;	   )
;	  ))))))
;
;: match ȤʤС
;
(defun res2section (res a0 a1 b0 b1)
  (cond 
   ((null res) nil)
   (t
    (let* ((sortres (sort (copy-list (rmbigres res)) #'>))
	   (ret (list (check-res (+ (max (abs (* 0.5 (car sortres))) 1)
				    (car sortres))
				 a0 a1 b0 b1))))
;	(pprint ret)
      (do ((l sortres (cdr l)))
	  ((atom (cdr l))
	   (push (car l) ret)
	   (push (check-res (- (car l) (max (abs (* 0.5 (car l))) 1))
			    a0 a1 b0 b1)
	      ret))
	(cond 
	 ((equal (car l) (cadr l)))
	 (t
	  (push (car l) ret)
	  (push (check-res 
		 (* 0.5 (+ (car l) (cadr l))) a0 a1 b0 b1) ret))))
      (do ((l ret (cddr l))
	   (sec)
	   (last))
	((atom (cdr l))
	 (and (car l) (push (cons last t) sec))
	 (nreverse sec))
	(cond ((eq (car l) t)
	       (and (eq (third l) 'nil) (push `(,last .,(second l)) sec)))
	      ((eq (car l) nil)
	       (cond ((eq (third l) t)
		      (setq last (cadr l)))
		     ((eq (third l) nil)
		      (push (cons (second l) (second l)) sec))
;		     (pprint sec)
		     )
	       )))))))
;
; element γ (ʳ) 򼡤ȿ˰ư̤κɸ֤
;: ΤȤ, local_margin Ͼ 0 ʤΤ element ˼ä֤Ƥ
;
(defparameter limit_margin 0.0)
(defun extend-element (element points limit_flag)
  (let* ((pp (cadr element)) (ret)(p0)(p1)(len)(rate)
	 (local_margin (cond (limit_flag 0) (limit_margin) (t 0.1))))
    (cond
     ((zerop local_margin) (mapcar #'(lambda (n) (nth n points)) pp))
     (t
      (setq p0 (nth (car pp) points)
            p1 (nth (cadr pp) points))
;      (and limit_flag (pprint limit_flag))
      (setq len (metric2 (car p0) (car p1)))
      (setq rate (/ (+ len local_margin) len))
      (push (list (plus2 (car p1) 
			 (times2 rate (diff2 (car p0) (car p1))))
		  (plus2 (cadr p1) 
			 (times2 rate (diff2 (cadr p0) (cadr p1)))))
	    ret)
      (do ((l (cddr pp) (cdr l)))
	  ((atom l)
	   (push (list (plus2 (car p0)
			      (times2 rate (diff2 (car p1) (car p0))))
		       (plus2 (cadr p0)
			      (times2 rate (diff2 (cadr p1) (cadr p0)))))
		 ret)
	   (nreverse ret))
	  (push p1 ret)
	  (setq p0 p1)
	  (setq p1 (nth (car l) points)))))))
;
;#  ñ˾ͤޤǤθ
;
(defun element-limit2 (points1 points2)
  (labels ((dfloat-2x2list (l) `((,(dfloat (caar l)) ,(dfloat (cadar l)))
				 (,(dfloat (caadr l)) ,(dfloat (cadadr l))))))
    (let ((section) 
	  (p22d) (p12d)) ; do* ϥ롼ѿμͤѤʤ
      (do* ((p2 points2 (cdr p2))
	    (p21 (car p2) p22)
	    (p21d (dfloat-2x2list p21) p22d)
	    (p22 (cadr p2) (cadr p2)))
	   ((atom (cdr p2)))
        (setq p22d (dfloat-2x2list p22))
	(do* ((p1 points1 (cdr p1))
	      (p11 (car p1) p12)
	      (p11d (dfloat-2x2list p11) p12d)
	      (p12 (cadr p1) (cadr p1)))
	     ((atom (cdr p1)))
	  (setq p12d (dfloat-2x2list p12))
	  (let ((res (append (crosst1 p11d p12d p21d)
			     (crosst1 p11d p12d p22d)
			     (crosst1 p21d p22d p11d)
			     (crosst1 p21d p22d p12d))))
	    (setq section
		  (orsection section
			     (res2section res p11 p12 p21 p22))))))
      section)))
;
; ֥ƱΤ()ʤפȤ񿨤 section 
;
; ƱΤξ硢extend-element Ǽ㴳;͵
;: (ߤ limit_margin  0.0 ꤷƤΤǡ extend Ƥʤ)
;
(defun element-limit1 (e1 p1 e2 p2)
  (let* ((points1)
	 (points2)
	 (limitflag (or (member (car e1) '(xlimit ylimit))
			(member (car e2) '(xlimit ylimit))))
	 )
;    (pprint (list e1 e2))
    (setq points1 (extend-element e1 p1 limitflag))
    (setq points2 (extend-element e2 p2 limitflag))
    (element-limit2 points1 points2)))
;
;#  2 ĤΥȤˤĤ suitable t  (ͤˤ餺). 
;
; element-limit1 ˤۤξ (ƱΤͤʤ) ȡ
; limit-section ˤ桼ξ (limitrule.l  deflimit Ƥ)
; Τɤ餫񿨤 t ϰϤ롣
;
(defun element-limit (element1 points1 element2 points2 param)
  (let* ((type1 (car element1))
	 (type2 (car element2))
	 (section 
	  (element-limit1 element1 points1 element2 points2)))
;   (pprint (list 'soko1 element1 element2 section))
    (do ((l (get 'alllimit 'limit)(cdr l)))
      ((atom l))
      (cond ((and (eq_member type1 (caaar l))
		  (eq_member type2 (cadaar l)))
	     (setq section
		   (orsection section 
			      (limit-section element1 points1 element2 points2 
					     param (cdar l))))
;	     (return)
	     )
	    ((and (eq_member type2 (caaar l))
		  (eq_member type1 (cadaar l)))
	     (setq section
		   (orsection 
		    section
		    (limit-section element1 points1 element2 points2
				   (cons '(reverse) param) (cdar l))))
;	     (return)
	     )))
    section))
;
(defun add0vector (points)
  (mapcar #'(lambda (x) (list x '(0 0))) points))
;
(defun addvector (points conv)
  (mapcar #'(lambda (x) (list x (affine x conv))) points))
;
; prim1  prim2  1 ĤĥȤäȹ礻ƤФơ
; 񿨤ϰϤơ section ιʻ֤
;
(defun general-section1 (prim1 prim2 param)
  (let* ((points1 (car prim1)) ; Ȥ⡢ 0vector ղ
	 (lines1 (cadr prim1))
	 (points2 (car prim2)) ; Ȥ⡢ conv ˤѴ̤ղ
	 (lines2 (cadr prim2))
	 (critical)
	 )
;   (pprint points1)
;   (pprint points2)
    (and (boundp 'DEBUG)(terpri))
    (do ((l lines1 (cdr l))
	 (sec))
      ((atom l)
       (and (boundp 'DEBUG1)(pprint critical))
       sec)
      (do ((ll lines2 (cdr ll))
	   (tsec)) ; temporary section
	((atom ll))
;	(break)
;	(pprint (list (car l) (car ll)))
	(setq tsec (element-limit (car l) points1 
				  (car ll) points2 param))
;(pprint (list 'tsec tsec))
(and (or (boundp 'DEBUG) (boundp 'DEBUG1)) ;<-----------------------------;
	(cond ((not (equal sec (orsection sec tsec)))                     ;
	       (and (boundp 'DEBUG)                                       ;  D 
		    (let ((*standard-output* *terminal-io*))              ;
		      (pprint `(,(car l),(car ll),(orsection sec tsec)    ;  E 
				,tsec                                     ;
				,(extend-element (car l) points1 nil)     ;  B
				,(extend-element (car ll) points2 nil)    ;
				))))                                      ;  U
	       (setq critical (list (car l) (car ll) (orsection sec tsec) ;
				    (extend-element (car l) points1 nil)  ;  G
				    (extend-element (car ll) points2 nil) ;
				    param))))                             ;
) ;<----------------------------------------------------------------------; 
	(setq sec (orsection sec tsec))
;	(pprint sec)
;(pprint (list 'sec sec))
	))))
;
(defun general-section (prim1 prim2 conv param)
  (general-section1 (cons (add0vector (car prim1)) (cdr prim1))
		    (cons (addvector (car prim2) conv) (cdr prim2))
		    param))
;
;#  s η
;#  1.0, t (s > 0 Τɤ s Ǥ褤), nil (ɤ s Ǥ)
;; tate, yoko ξ硢ºݤˤϿ֤ͤͤʤȺ
;
; (ʻѤߤ)  section 񿨤 s ϰϤݻƤ롣
; ­ s κ (section 佸Τ0 ޤ֤ξ)
; ֤
; 0 ޤפȤƤΤϡʤ֤Ǥ郎
; 뤳ȤŤ˲ꤷƤꡢs Ϣ³Ūäƾǽˤõ
; 뤫顣
;
(defun section2s (section)
  (cond (section
	 (do ((l section (cdr l)))
	     ((atom l) t)
	   (cond ((eq (cdar l) 't)	     ; ü = +ζ֤ä
		  (return (rm-eq (caar l)))) ; ζ֤βü֤
		 ((and (cdar l) (plusp (rm-eq (cdar l))))
		  (return (rm-eq (caar l)))))))
	(t))) ; sectionnilʤt֤
;
;#  prim1  prim2 * (I + t * conv) Ȥ褦ʺ t 
;;                    I  identity matrix
;#  , ̩ˤäѤΤ, paramͿ
;#  param  '((yunit 0 . 400) (xunit 0 . 200))) Τ褦ʷ
;-----------------------------------------------------------------------------
; general-limit: ǽʺѷ̤ 
;
; prim1 ꤷ prim2 ֤ѷ (ưʤ) ƹԤäȤˡ
; ñѴ conv βܤޤѴܤƤ褤
;-----------------------------------------------------------------------------
(defun general-limit (prim1 prim2 conv param)
  (section2s (general-section prim1 prim2 conv param)))

;#  affine Ϥ褦. +ʿ԰ư (濴 + X,YΨ + ʿ԰ưX,Y)
;
;# ޤǤˡǤ, ٤ƤδطǤȤ館ƤΤ, 
;# 䤦Τ
;#
;# Ϳѥ᡼ pointarray  2 Ĥ vectorarray
